import 'package:flutter/material.dart';
import 'package:flutter_form_builder_ing/flutter_form_builder_ing.dart';
import 'package:layout_form_builder/datalayer/constant/eform_constants.dart';
import 'app_setting.dart';
import 'datalayer/bean/eform_source.dart';
import 'form_and_layout_build.dart';

class DynamicPage extends StatefulWidget {
  final String pageId;

  DynamicPage({Key? key, required this.pageId}) : super(key: key);

  @override
  _DynamicPageState createState() => _DynamicPageState();
}

class _DynamicPageState extends State<DynamicPage> {
  late FormSource _source;
  late GlobalKey<FormBuilderState> formKey;

  @override
  void initState() {
    formKey = GlobalKey();
    _source = FormSource(
      url: "${AppSetting.serverUrlPrefix}/entry/form/fetchEntryFormJson/${EFormConstants.FORM_PAGE_ID_VAR}"
    );
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: Colors.grey[300],
      appBar: AppBar(
        title: Text("Entry Form", style: TextStyle(fontFamily: 'Lato')),
        actions: [
          IconButton(icon: Icon(Icons.upload_file), onPressed: () {})
        ],
      ),
      body: Padding(
        padding: EdgeInsets.all(20),
        child: SingleChildScrollView(
            child: Column(
          mainAxisAlignment: MainAxisAlignment.start,
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [_getDynamicForm()],
        ))
      )
    );
  }

  Widget _getDynamicForm() {
    return Container(
      width: double.infinity,
      child: EFormDynamicLayout(
        formKey: formKey,
        source: _source,
        dataLoader: () async{
          return Map<String, dynamic>();
        },
        pageId: widget.pageId
      )
    );
  }
}
