import 'package:dynamic_widget/dynamic_widget.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:layout_form_builder/datalayer/bean/eform_cache.dart';
import 'package:layout_form_builder/datalayer/constant/eform_parser.dart';
import 'package:layout_form_builder/datalayer/constant/eform_properties.dart';
import '../formcomponent/partial_size_column.dart';

class PartialSizeColumnParser extends WidgetParser {
  @override
  String get widgetName => EFormWidgetParser.PartialSizeColumn.value;

  @override
  Widget parse(Map<String, dynamic> map, BuildContext buildContext, ClickListener? listener) {
    final id = EFormCache.fieldString(map, EFormProperties.PROP_INPUT_ID) ?? "";
    final label = EFormCache.fieldString(map, EFormProperties.PROP_INPUT_LABEL) ?? "";
    final visible = EFormCache.fieldBool(map, EFormProperties.PROP_INPUT_VISIBLE, defaultValue: true);
    final flex = EFormCache.fieldInt(map, EFormProperties.PROP_FLEX) ?? 1;
    final compulsory = EFormCache.fieldBool(map, EFormProperties.PROP_COMPULSORY, defaultValue: false);
    final child = EFormCache.fieldDynamic(map, EFormProperties.PROP_CHILD);

    return PartialSizeColumn(
      id: id,
      label: label,
      visible: visible,
      flex: flex,
      compulsory: compulsory,
      child: DynamicWidgetBuilder.buildFromMap(child, buildContext, listener)!
    );
  }

  @override
  Type get widgetType => PartialSizeColumn;

  @override
  Map<String, dynamic>? export(Widget? widget, BuildContext? buildContext) {
    return Map<String, dynamic>();
  }
}
